/**
 * @file yapplication.cc
 * @brief ץꥱΤ ()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#include <btron/libapp.h>
#include <keycode.h>
#include "yapplication.h"

/** ٥ȥ롼׽μ¹
 * ٥ȥ롼׽¹Ԥλ˽λɤ֤
 * @return λ
 */
W YApplication::run()
{
  W evType;
  YWindow* win;
  WEVENT event;
  // if (event.s.wid != windowID) outside of window
  // if(event.s.cmd != W_WORK) outside of working area

  do {
    evType = wget_evt(&event, evmode);
    win = getWindow(event.g.wid);

    switch (evType){
      
    case EV_MSG:
      // clr_msg(MM_ALL,MM_ALL);
      break; // usual events

    case EV_MENU:
      break; // menu manipulation
      
    case EV_REQUEST:
      switch (event.r.cmd){
        
      case W_REDISP:
        if (win != NULL){
          win->onRepaint();
        }
        break;
        
      case W_PASTE:
        wrsp_evt(&event,YWindow::NACK);
        // closeWindow();
        break;
        
      case W_FINISH:
        wrsp_evt(&event,YWindow::ACK);
        if (win != NULL){
          win->closeWindow();
        }
        terminate(0);
        // return event.g.cmd
        break;
        
      case W_DELETE:
        wrsp_evt(&event,YWindow::ACK);
        // save Document here!
        //  ---
        if (win != NULL){
          win->closeWindow();
        }
        terminate(0);
        break;
        
      default:
        break; // ignore the rests
        
      }
      break;
      
    case EV_INACT:
      // ex: no-op
      break;
      
    case EV_RSWITCH:
      if (win != NULL){
        win->onRepaint();
      }
    case EV_SWITCH:
      if (event.s.cmd < W_WORK || event.s.cmd > W_LBAR){
        break;
      }
    case EV_BUTDWN:
      if (win != NULL){
        win->onMouseButtonDown(&event);
      }
      break;
    case EV_BUTUP:
      if (win != NULL){
        win->onMouseButtonUp(&event);
      }
      break;

    case EV_KEYDWN:
      win = getWindow(wget_act(NULL));
      if (win != 0){
        win->onKeyDown(&event);
        win->onKeyTyped(&event);
      }
      break;
    case EV_AUTKEY:
      // key inputs
      win = getWindow(wget_act(NULL));
      if (win != 0){
        if (event.s.cmd == KC_SS_D || event.s.cmd == KC_SS_U){
          win->onMouseWheel(&event);
        }
        else {
          win->onKeyTyped(&event);
        }
      }
      break;
    case EV_KEYUP:
      win = getWindow(wget_act(NULL));
      if (win != 0){
        win->onKeyUp(&event);
      }
      break;

    case EV_NOMSG:
      //break; // happens only if NOWAIT
    case EV_NULL:
      if (event.s.cmd == W_WORK){
        //gset_ptr(PS_SELECT,NULL,-1,-1);
        setpointer(PS_SELECT,NULL);
      }
      /*if (win != NULL){
        win->onIdle(&event);
      }*/
      for (std::map<W,YWindow*>::iterator i = hashWnd.begin(); i != hashWnd.end(); i++){
        i->second->onIdle(&event);
      }
      break;
      //if (event.s.stat & ES_CMD){
      // command key pressed
      //break;
      //}
      //setpointer(PS_SELECT,NULL);

    case EV_DEVICE:
      // FD inserted
      oprc_dev(&event.e,NULL,0);
      break;
      
    default:
      // others
      break;
    }
  } while (!toBeKilled);
  
  return ret_code;
}

/** ɥϿԤ
 *
 * ɥ٥Ȥʬ褦ɥϿԤ<br>
 * <strong></strong>: YWindow¦˰뤳Ȥ⸡Ƥ档
 * ѹβǽ⤤Τդ뤳ȡ
 * @param win Ͽ륦ɥ
 */
void YApplication::registerWindow(YWindow *win)
{
  hashWnd.insert(std::pair<W,YWindow*>(win->getWindowID(),win));
}

/** WID饦ɥ
 *
 * Ϳ줿WID(ɥID)б륦ɥ(YWindow)ؤ
 * ݥ󥿤
 * @param wid ɥID
 * @retval NULL ɥĤʤä
 * @retval NULLʳ YWindowؤΥݥ
 */
YWindow* YApplication::getWindow(W wid)
{
  std::map<W,YWindow*>::iterator p;
  p = hashWnd.find(wid);

  if (p != hashWnd.end()){
    return p->second;
  }
  else {
    return NULL;
  }
}

/** ץνλ
 *
 * ٥ȥ롼״ؿrun()ȴФơľ˥ץλޤ
 * @param rcode λ
 */
void YApplication::terminate(W rcode)
{
  toBeKilled = True;
  ret_code = rcode;
}

/** ٥Ƚ⡼ɤ
 *
 * ٥Ȥν⡼ɤꤷޤͭͤWAIT, NOWAITͤǤ
 * @param evm ٥Ƚ⡼
 */
void YApplication::setEventMode(W evm)
{
  evmode = evm;
}

