/**
 * @file ygraphic.h
 * @brief եå
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YGRAPHIC
#define DEFINE_H_YGRAPHIC

#include <basic.h>
#include <bstdlib.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/tip.h>
#include <btron/libapp.h>
#include <tstring.h>
#include "ypen.h"
#include "ybrush.h"
#include "ypoint.h"
#include "yrect.h"

/** եå襤󥿥ե
 *
 * եåΥ󥿥ե󶡤ޤŪˤϡ
 * ǥץ쥤ץߥƥ֤ˤ뵡ǽ󶡤ޤ
 */
class YGraphic {

public:
  /// ǥեȥ󥹥ȥ饯
  YGraphic();
  
  /// 󥹥ȥ饯(Ķ(GID)ȴϢŤԤ)
  YGraphic(W gid);
  
  /// ǥȥ饯
  virtual ~YGraphic() {};
  
  /** Ķ
   *
   * ĶꤷȤоݤȤޤ
   * @param gid Ķ(GID)
   */
  void setGraphID(W gid) {
    graphID = gid;
  }
  
  /** ߤĶμ
   *
   * ߤĶ֤ޤ
   * @return Ķ
   */
  W getGraphID() {
    return graphID;
  }
  
  /// ߤΥڥڤؤ
  YPen* setPen(YPen *pen);
  
  /// ߤΥ֥饷ڤؤ
  YBrush* setBrush(YBrush *brush);

  /// ɸڥ֤
  static YPen* getStdPen();
  
  /// ɸ֥饷֤
  static YBrush* getStdBrush();

  /** ٤
   *
   * ٤0ٰʾ塦360̤ϰϤ롣
   * @param deg - 
   * @return 줿
   */
  static int adjustDeg(int deg) {
    deg %= 360;
    if (deg < 0){
      deg += 360;
    }
    return deg;
  }
  
  /// 
  void line(const YPoint& p1, const YPoint& p2);
  
  /// 
  void setPixel(const YPoint& p1);

  /// Υѥ
  void fillPixel(const YPoint& p1);
  
  /// ĹȤ
  void frameRect(const YRect& rect, W deg = 0);

  /// ĹΰɤĤ֤
  void fillRect(const YRect& rect, W deg = 0);

  /// ѴĹȤ
  void frameRoundRect(const YRect& rect, W rx, W ry, W deg = 0);

  /// ѴĹΰɤĤ֤
  void fillRoundRect(const YRect& rect, W rx, W ry, W deg = 0);

  /// ʱȤ
  void frameOval(const YRect& rect, W deg = 0);
  
  /// ʱΰɤĤ֤
  void fillOval(const YRect& rect, W deg = 0);
  
  /// ̤
  void arc(const YRect& rect, const YPoint& sp, const YPoint& ep, W deg = 0);

  /// Ȥ
  void frameSector(const YRect& rect, const YPoint& sp, const YPoint& ep, W deg = 0);

  /// ΰɤĤ֤
  void fillSector(const YRect& rect, const YPoint& sp, const YPoint& ep, W deg = 0);

  /// ݷȤ
  void frameChord(const YRect& rect, const YPoint& sp, const YPoint& ep, W deg = 0);

  /// ݷΰɤĤ֤
  void fillChord(const YRect& rect, const YPoint& sp, const YPoint& ep, W deg = 0);

  /// ǤΰɤĤ֤
  void floodFill(const YPoint& pt);

  /// ǤΰɤĤ֤
  void floodFill(const YPoint& pt, const YColor& bound);
  
  // void polyLine - gdra_pln
  // void polygon - gfra_pol
  // void fillScan - gfil_scn
  // void spline - gdra_spl
  //  * the above is just 2-66 to 2-97
  
  
protected:

private:
  /// Ķ
  W graphID;
  /// ߻Υڥ
  YPen* currentPen;
  /// ߻Υ֥饷
  YBrush* currentBrush;
  /// ɸڥ
  static YPen *stdPen;
  // ɸ֥饷
  static YBrush *stdBrush;

};

#endif // DEFINE_H_YGRAPHIC
