// ------------------------------------
//  YLib version ???
//  (C)Copyright 2003, Yashiro Takeshi
// ------------------------------------
//  This is free software, and you are welcome to redistribute it
//  under certain conditions; see COPYING.txt for details.

// #include NDEBUG // assertion̵ˤ
#include <ystring.h>
#include <bassert.h>

void YString::freeInstance()
{
  if (strInstance != NULL){
    strInstance->refcount--;
    if (strInstance->refcount <= 0){
      assert(strInstance->refcount == 0); // debug assertion
      delete [] strInstance->tcstr;
      delete strInstance;
    }
    strInstance = NULL;
  }
}

/** 󥹥ȥ饯
 *
 * 󥹥ȥ饯Ϣ³repeatĤTRONCODEʸϢ³ǽޤ
 * @param chr TRONCODEʸ
 * @param repeat ʸϢ³
 */
YString::YString(TC chr, int repeat)
{
  strInstance = allocNewBuffer(repeat + 1);
  tc_strset(strInstance->tcstr, chr, repeat);
  strInstance->tcstr[repeat] = TNULL;
}

YString::operator const TC*() const
{
  static TC nullstr = TNULL;
  
  if (strInstance != NULL){
    return strInstance->tcstr;
  }
  return &nullstr; // staticʤΤǰĤΤϤ
}

const YString& YString::operator=(const YString& src)
{
  // ԡ衦ԡƱϲ⤷ʤ
  if (strInstance != src.strInstance){
    freeInstance();
    strInstance = src.strInstance;
    if (strInstance != NULL){
      strInstance->refcount++;
    }
  }
  return *this;
}


const YString& YString::operator=(const TC* src)
{
  freeInstance();
  if (src != NULL){
    strInstance = allocNewBuffer(tc_strlen(src)+1);
    tc_strcpy(strInstance->tcstr, src);
  }
  return *this;
}


YStringInstance* YString::allocNewBuffer(int size)
{
  YStringInstance *ins = new YStringInstance;
  
  if (size <= 32){
    ins->bufsize = 32;
  }
  else if (size <= 64){
    ins->bufsize = 64;
  }
  else if (size <= 128){
    ins->bufsize = 128;
  }
  else if (size <= 256){
    ins->bufsize = 256;
  }
  else {
    ins->bufsize = size;
  }
  
  ins->tcstr = new TC[ins->bufsize];
  ins->datalen = size;
  ins->refcount = 1;
  // ̵̤˷׻ƤޤȤʤᡢʲٱ׻
  ins->len = -1; 
  ins->lastzone = -1;
  
  return ins;
}

//YString::forceUnique()
void YString::calcStringInfo() const
{
  if (strInstance == NULL){
    return;
  }
  if (strInstance->len < 0 || strInstance->datalen < 0 ||
      strInstance->lastzone < 0){
    int curlen = 0, curdatalen = 1, curzone = TSC_SYS, tmp;
    for (int i=0; strInstance->tcstr[i] != TNULL; i++){
      curdatalen++;
      int n = 0;
      tmp = isTLANGch(strInstance->tcstr[i], &n);
      if (tmp != 0){
        curzone = tmp;
      }
      else {
        curlen++;
      }
    }
    strInstance->len = curlen;
    strInstance->lastzone = curzone;
    strInstance->datalen = curdatalen;
  }
}

// -- ʲХ黻

/*void YString::forceUnique(int size)
{
  ;
}*/

//void YString::concatCopy()

YString concat(const TC* s1, const TC* s2)
{
  YString res;
  int n = 0;
  
  // ֤TSC_SYSäʤTCʬ;뤬ʤȤ
  res.strInstance = res.allocNewBuffer(tc_strlen(s1) + tc_strlen(s2) + 2);
  tc_strcpy(res.strInstance->tcstr, s1);
  mtc_strcat(res.strInstance->tcstr, s2); // ʸڤؤб
  return res;
}

YString operator+(const YString& s1, const YString& s2)
{
  if (s2.strInstance == NULL){
    return s1;
  }
  else if (s1.strInstance == NULL){
    return s2;
  }
  return concat((const TC*)const_cast<YString&>(s1),
                (const TC*)const_cast<YString&>(s2));
}

YString operator+(const YString& str, const TC* tcs)
{
  if (tcs[0] == TNULL){
    return str;
  }
  return concat((const TC*)const_cast<YString&>(str), tcs);
}

YString operator+(const TC* tcs, const YString& str)
{
  if (tcs[0] == TNULL){
    return str;
  }
  return concat(tcs, (const TC*)const_cast<YString&>(str));
}

// '+=' 黻ҤǤФäȺŬ򤹤٤
YString operator+(TC chr, const YString& str)
{
  if (chr == TNULL){
    return str;
  }
  else {
    TC tmp[] = { chr, TNULL };
    return concat(tmp, (const TC*)const_cast<YString&>(str));
  }
}

YString operator+(const YString& str, TC chr)
{
  if (chr == TNULL){
    return str;
  }
  else {
    TC tmp[] = { chr, TNULL };
    return concat((const TC*)const_cast<YString&>(str), tmp);
  }
}

