/**
 * @file ywindow.h
 * @brief ݥɥ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YWINDOW
#define DEFINE_H_YWINDOW

#include <basic.h>
#include <bstdlib.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/tip.h>
#include <btron/libapp.h>
#include <tstring.h>
#include "ystring.h"
#include "ygraphic.h"
#include "yrect.h"
#include "ypoint.h"
#include "yexception.h"

/** ɥط㳰
 *
 * ɥط㳰򰷤ޤ
 */
class YWindowException : public YException {
public:
  YWindowException(W n = 0) : YException(n) {}
  YWindowException(const YString& str, W n = 0)
    : YException(str, n) {}
};

/** ݥɥ
 *
 * ɥδ쥯饹ǤС饤ɤǡʤȤ
 * ٥ȯνؿ(onXXXX)ξ˱
 * ɥƤ
 */
class YWindow {

public:
  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯ɥκɸꤷƽޤ
   * @param rect ɥɽ
   */
  YWindow(const YRect& rect) {
    windowID = -1;
    winAttr = WA_STD;
    pictogram = 2;
    toBeKilled = False;
    setPosition(rect);
  }

  /** ǥեȥ󥹥ȥ饯
   *
   * 󥹥ȥ饯Ǥ󥹥ȥ饯ƤФ줿Ǥ
   * ɥɽޤΤդƤ
   */
  YWindow() {
    windowID = -1;
    winAttr = WA_STD;
    pictogram = 2;
    toBeKilled = False;
    YRect rect(20, 20, 420, 320);    
  }

  /// ǥȥ饯
  virtual ~YWindow() {
    closeWindow();
  }
      
  /// ɥ򳫤
  virtual void openWindow();
  
  /// ɥĤ
  virtual void closeWindow();
  
  /// ɥID֤
  W getWindowID(){
    return windowID;
  }
  
  /// ɥΥȥ
  void setTitle(const YString& tcstr);

  /** ɥΰ֤
   *
   * ɥɽ֤ꤷޤ
   * @param rect ɽ
   */
  void setPosition(const YRect& rect) {
    position = rect;
  }
  
  // ɥΰ֤
  // void setClientRect(YRect rect);

  /** 饤ΰкɸ
   *
   * ߤΥ饤ΰкɸޤ
   * @param rect ɸγǼ
   */
  void getClientRect(YRect *rect){
    wget_wrk(windowID, (RECT*)rect);
  }
  
  /// ɥ°
  void setAttributes(UW wa);
  
  /** ɥ襪֥Ȥμ
   *
   * ɥФ褹뤿 YGraphic ֥Ȥޤ
   * Ѹɬ delete 褦ˤƤ
   */
  YGraphic* createGraphic() {
    W graphID = wget_gid(windowID);
    return new YGraphic(graphID);
  }

  /// 襤٥ȤΥϥɥ
  virtual void onRepaint();
  ////////////////////
  // ΰΤߤ˸ꤷ襤٥ȤΥϥɥ
  //   [in] gr - եå饹ؤΥݥ
  virtual void onDraw(YGraphic *gr) {}
  ////////////////////
  // ޥܥ󤬲줿Υ٥ȥϥɥ
  virtual void onMouseButtonDown(WEVENT *ev);
  ////////////////////
  // ޥܥ줿Υ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onMouseButtonUp(WEVENT *ev){}; // not implemented as of yet
  ////////////////////
  // ⥤٥ȤʤΥ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onIdle(WEVENT *ev){}; // not implemented as of yet
  ////////////////////
  // 줿Υ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onKeyDown(WEVENT *ev){}; // not implemented as of yet
  ////////////////////
  // 줿Υ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onKeyTyped(WEVENT *ev){}; // not implemented as of yet
  ////////////////////
  // 줿Υ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onKeyUp(WEVENT *ev){}; // not implemented as of yet
  ////////////////////
  // ޥۥ뤬Ԥ줿Υ٥ȥϥɥ - NOT IMPLEMENTED AS OF YET
  virtual void onMouseWheel(WEVENT *ev){}; // not implemented as of yet
  
  /// ACK
  const static W ACK  = 0;
  
  /// NACK
  const static W NACK = 1;
  
protected:
  /// ɥID
  W windowID;
  ////////////////////
  // ɥΥԥȥ
  W pictogram;
  ////////////////////
  // ɥΰ
  YRect position;

private:
  ////////////////////
  // ɥμ : Like WA_NORMAL, ...
  UW winAttr;
  ////////////////////
  // ɥΥȥ
  YString title;
  ////////////////////
  // 顼
  W err;
  ////////////////////
  // λ(롼פȴ뤫ɤ)Υե饰
  BOOL toBeKilled;

};

#endif // DEFINE_H_YWINDOW
